- Main Page
- Tutorials
- Functions
- Release Notes
- Examples

Functions
sum
Complete List of ArrayFire Functions ArrayFire Functions by Category » Vector Algorithms » | Reduction operations

Find the sum of values in the input. More...

## Functions
AFAPI array | sum (const array &in, const int dim=-1)
| C++ Interface for sum of elements in an array. More...
AFAPI array | sum (const array &in, const int dim, const double nanval)
| C++ Interface for sum of elements in an array while replacing nan values. More...
template<typename T >
T | sum (const array &in)
| C++ Interface for sum of all elements in an array. More...
template<typename T >
T | sum (const array &in, double nanval)
| C++ Interface for sum of all elements in an array while replacing nan values. More...
AFAPI af_err | af_sum (af_array *out, const af_array in, const int dim)
| C Interface for sum of elements in an array. More...
AFAPI af_err | af_sum_nan (af_array *out, const af_array in, const int dim, const double nanval)
| C Interface for sum of elements in an array while replacing nans. More...
AFAPI af_err | af_sum_all (double *real, double *imag, const af_array in)
| C Interface for sum of all elements in an array. More...
AFAPI af_err | af_sum_nan_all (double *real, double *imag, const af_array in, const double nanval)
| C Interface for sum of all elements in an array while replacing nans. More...

## Detailed Description

Find the sum of values in the input.

This function performs the operation across all batches present in the input simultaneously.

## Function Documentation

AFAPI af_err af_sum | ( | af_array * | out,
|  | const af_array | in,
|  | const int | dim
| ) |  |

C Interface for sum of elements in an array.

Parameters

  [out] | out | will contain the sum of all values in `in` along `dim`
  [in] | in | is the input array
  [in] | dim | The dimension along which the add operation occurs

Returns
  AF_SUCCESS if the execution completes properly

AFAPI af_err af_sum_all | ( | double * | real,
|  | double * | imag,
|  | const af_array | in
| ) |  |

C Interface for sum of all elements in an array.

Parameters

  [out] | real | will contain the real part of adding all elements in input `in`
  [out] | imag | will contain the imaginary part of adding all elements in input `in`
  [in] | in | is the input array

Returns
  AF_SUCCESS if the execution completes properly

Note
  `imag` is always set to 0 when `in` is real

AFAPI af_err af_sum_nan | ( | af_array * | out,
|  | const af_array | in,
|  | const int | dim,
|  | const double | nanval
| ) |  |

C Interface for sum of elements in an array while replacing nans.

Parameters

  [out] | out | will contain the sum of all values in `in` along `dim`
  [in] | in | is the input array
  [in] | dim | The dimension along which the add operation occurs
  [in] | nanval | Replace nans with the value passed to this function

Returns
  AF_SUCCESS if the execution completes properly

AFAPI af_err af_sum_nan_all | ( | double * | real,
|  | double * | imag,
|  | const af_array | in,
|  | const double | nanval
| ) |  |

C Interface for sum of all elements in an array while replacing nans.

Parameters

  [out] | real | will contain the real part of adding all elements in input `in`
  [out] | imag | will contain the imaginary part of adding all elements in input `in`
  [in] | in | is the input array
  [in] | nanval | is the value which replaces nan

Returns
  AF_SUCCESS if the execution completes properly

Note
  `imag` is always set to 0 when `in` is real

AFAPI array af::sum | ( | const array & | in,
|  | const int | dim = `-1`
| ) |  |

C++ Interface for sum of elements in an array.

Parameters

  [in] | in | is the input array
  [in] | dim | The dimension along which the add operation occurs

Returns
  result of sum all values along dimension `dim`

Note
  `dim` is -1 by default. -1 denotes the first non-singleton dimension.

Examples:
  deep_belief_net.cpp, integer.cpp, kmeans.cpp, logistic_regression.cpp, naive_bayes.cpp, rainfall.cpp, rbm.cpp, softmax_regression.cpp, and vectorize.cpp.

AFAPI array af::sum | ( | const array & | in,
|  | const int | dim,
|  | const double | nanval
| ) |  |

C++ Interface for sum of elements in an array while replacing nan values.

Parameters

  [in] | in | is the input array
  [in] | dim | The dimension along which the add operation occurs
  [in] | nanval | Replace nans with the value passed to this function

Returns
  result of sum all values along dimension `dim`

T af::sum | ( | const array & | in | ) |

C++ Interface for sum of all elements in an array.

Parameters

  [in] | in | is the input array

Returns
  the sum of all values of `in`

T af::sum | ( | const array & | in,
|  | double | nanval
| ) |  |

C++ Interface for sum of all elements in an array while replacing nan values.

Parameters

  [in] | in | is the input array
  [in] | nanval | Replace nans with the value passed to this function

Returns
  the sum of all values of `in`